﻿<?php

require_once ('jpgraph/jpgraph.php');
require_once ('jpgraph/jpgraph_line.php');

$image_w  = 470;
$image_h  = 240;
$margin_t = 24;
$margin_l = 50;
$margin_r = 20;
$margin_b = 24;

$graph = new Graph($image_w, $image_h);

$graph->clearTheme();
$graph->SetScale("linlin", 0, 0, -7, 1);
// $graph->SetScale("linlin", 2800, 3700, -7, 1);

$graph->SetMargin($margin_l, $margin_r, $margin_t, $margin_b);
$graph->img->SetAntiAliasing();

$graph->xaxis->HideLine(false);
$graph->xaxis->HideTicks(true, false);                      // minor, major
$graph->xaxis->SetPos('min');
$graph->xaxis->SetLabelFormat('%d');
$graph->xaxis->scale->ticks->Set(1, 0.25);	

$graph->xgrid->Show(true, true);
$graph->xgrid->SetColor('#A0A0A0', '#E0E0E0');
$graph->xgrid->SetLineStyle('solid');

$graph->yaxis->HideLine(false);        
$graph->yaxis->HideTicks(true, false);                      // minor, major
$graph->yaxis->SetPos('min');
$graph->yaxis->SetLabelFormat('%d');
// $graph->yaxis->scale->ticks->Set(100, 50);	

$graph->ygrid->Show();
$graph->ygrid->SetColor('#A0A0A0', '#E0E0E0');
$graph->ygrid->SetLineStyle('solid');

$sp01 = new LinePlot($vCell01, $tTime);
$sp01->SetColor('#000000');
$graph->Add($sp01);

$sp02 = new LinePlot($vCell02, $tTime);
$sp02->SetColor('#002020');
$graph->Add($sp02);

$sp03 = new LinePlot($vCell03, $tTime);
$sp03->SetColor('#004040');
$graph->Add($sp03);

$sp04 = new LinePlot($vCell04, $tTime);
$sp04->SetColor('#006060');
$graph->Add($sp04);

$sp05 = new LinePlot($vCell05, $tTime);
$sp05->SetColor('#008080');
$graph->Add($sp05);

$sp06 = new LinePlot($vCell06, $tTime);
$sp06->SetColor('#00a0a0');
$graph->Add($sp06);

$sp07 = new LinePlot($vCell07, $tTime);
$sp07->SetColor('#00c0c0');
$graph->Add($sp07);

$sp08 = new LinePlot($vCell08, $tTime);
$sp08->SetColor('#00e0e0');
$graph->Add($sp08);

$sp09 = new LinePlot($vCell09, $tTime);
$sp09->SetColor('#202000');
$graph->Add($sp09);

$sp10 = new LinePlot($vCell10, $tTime);
$sp10->SetColor('#404000');
$graph->Add($sp10);

$sp11 = new LinePlot($vCell11, $tTime);
$sp11->SetColor('#606000');
$graph->Add($sp11);

$sp12 = new LinePlot($vCell12, $tTime);
$sp12->SetColor('#808000');
$graph->Add($sp12);

$sp13 = new LinePlot($vCell13, $tTime);
$sp13->SetColor('#a0a000');
$graph->Add($sp13);

$sp14 = new LinePlot($vCell14, $tTime);
$sp14->SetColor('#c0c000');
$graph->Add($sp14);

$sp15 = new LinePlot($vCell15, $tTime);
$sp15->SetColor('#e0e000');
$graph->Add($sp15);

$sp16 = new LinePlot($vCell16, $tTime);
$sp16->SetColor('#ff00ff');
$graph->Add($sp16);

unlink('chart_batt2.png');

$graph->Stroke('chart_batt2.png');

?>