﻿<?php

require_once ('jpgraph/jpgraph.php');
require_once ('jpgraph/jpgraph_line.php');

$image_w  = 660;
$image_h  = 260;

$margin_t = 26;
$margin_l = 50;
$margin_r = 20;
$margin_b = 24;

$graph = new Graph($image_w, $image_h);

$graph->clearTheme();
$graph->SetScale("linlin", 0, 0, -2, 1);

$graph->SetMargin($margin_l, $margin_r, $margin_t, $margin_b);
$graph->img->SetAntiAliasing();

$graph->xaxis->HideLine(false);
$graph->xaxis->HideTicks(true, false);                      // minor, major
$graph->xaxis->SetPos('min');
$graph->xaxis->SetLabelFormat('%d');
$graph->xaxis->scale->ticks->Set(1, 0.125);	

$graph->xgrid->Show(true, true);
$graph->xgrid->SetColor('#A0A0A0', '#E0E0E0');
$graph->xgrid->SetLineStyle('solid');

$graph->yaxis->HideLine(false);        
$graph->yaxis->HideTicks(true, false);                      // minor, major
$graph->yaxis->SetLabelFormat('%d');
$graph->yaxis->SetPos('min');

$graph->ygrid->Show();
$graph->ygrid->SetColor('#A0A0A0', '#E0E0E0');
$graph->ygrid->SetLineStyle('solid');

$sp1 = new LinePlot($yy_g[0], $xx_t);
$graph->Add($sp1);
$sp1->SetColor('#F02020');
$sp1->SetLegend($gp_txt[0]);

if (count($yy_g) > 1) {
    $sp2 = new LinePlot($yy_g[1], $xx_t);
    $graph->Add($sp2);
    $sp2->SetColor('#20F020');
    $sp2->SetLegend($gp_txt[1]);
}

if (count($yy_g) > 2) {
    $sp3 = new LinePlot($yy_g[2], $xx_t);
    $graph->Add($sp3);
    $sp3->SetColor('#2020F0');
    $sp3->SetLegend($gp_txt[2]);
}

$graph->legend->SetAbsPos(($image_w - $margin_l - $margin_r) / 2 + $margin_l, 1, 'center', 'top');
$graph->legend->SetFrameWeight(0);
$graph->legend->SetLayout(LEGEND_HOR);

unlink('chart_panel1.png');

$graph->Stroke('chart_panel1.png');

?>