﻿<?php

// Create connection
$conn = mysqli_connect($dbserver, $username, $password, $database);

// Get Latest Record
$sql     = "SELECT * FROM solar_meter ORDER BY id DESC LIMIT 1";
$res     = mysqli_query($conn, $sql);
if (mysqli_num_rows($res) > 0) {
    $row     = mysqli_fetch_assoc($res);
    $tTime   = $row["id"];
    $pNow    = $row["pNow"];
    $pLife   = $row["pLife"];
    $pVolt   = $row["pVolt"] / 1000;
    $pCurr   = $pNow / $pVolt;
    $cNowL1  = $row["cNowL1"];
    $cLifeL1 = $row["cLifeL1"];
    $cVoltL1 = $row["cVoltL1"] / 1000;
    $cCurrL1 = $pNow / $pVolt;
    $cNowL2  = $row["cNowL2"];
    $cLifeL2 = $row["cLifeL2"];
    $cVoltL2 = $row["cVoltL2"] / 1000;
    $cCurrL2 = $pNow / $pVolt;
    $cNow    = $cNowL1 + $cNowL2;
    $cLife   = $cLifeL1 + $cLifeL2;
    $cVolt   = $cVoltL1 + $cVoltL2;
    $cCurr   = $cNow / $cVolt;
    $iNow    = $row["iNow"];
    $iLife   = $row["iLife"];
    $iCount  = $row["iCount"];
}

//==============================================================================
// Today  
//==============================================================================
$time_st = intval((time() - $tz_adj) / 24 / 3600) * 24 * 3600 + $tz_adj;
$time_lt = $time_st + 24 * 3600;
$sql     = "SELECT * FROM solar_meter WHERE id >= $time_st ORDER BY id LIMIT 1";
$res     = mysqli_query($conn, $sql);
if (mysqli_num_rows($res) > 0) {
    $row    = mysqli_fetch_assoc($res);
    $tDay   = $tTime - $row["id"];
    $pDay   = $pLife - $row["pLife"];
    $cDay   = $cLife - $row["cLifeL1"] - $row["cLifeL2"];
}
else {
	  $tDay   = 0;
    $pDay   = 0;
    $cDay   = 0;
}

//==============================================================================
// Get Latest Seven Days 
//==============================================================================
$time_st = time() - (7 * 24 * 3600) + $tz_adj;
$sql     = "SELECT * FROM solar_meter WHERE id >= $time_st ORDER BY id LIMIT 1";
$res     = mysqli_query($conn, $sql);
if (mysqli_num_rows($res) > 0) {
    $row    = mysqli_fetch_assoc($res);
    $tSeven = $tTime - $row["id"];
    $pSeven = $pLife - $row["pLife"];
    $cSeven = $cLife - $row["cLifeL1"] - $row["cLifeL2"];
}
else {
	  $tSeven = 0;
    $pSeven = 0;
    $cSeven = 0;
}

//==============================================================================
// - 7 to 1, data for graph
//==============================================================================
$x_t     = array();
$y_p     = array();
$y_c     = array();
$y_n     = array();
$time_st = intval((time() - $tz_adj) / 24 / 3600) * 24 * 3600 + $tz_adj;
$time_sd = $time_st - (6 * 24 * 3600);
$time_lt = $time_st + (1 * 24 * 3600);
$sql     = "SELECT * FROM solar_meter WHERE id >= $time_sd AND id <= $time_lt ORDER BY id ASC";
$res     = mysqli_query($conn, $sql);
$found   = mysqli_num_rows($res);
if ($found > 0) {
  	for ($i = 0; $i < $found; $i++) {
		    $row   = mysqli_fetch_assoc($res);
		    $p_now = $row["pNow"];
		    $c_now = $row["cNowL1"] + $row["cNowL2"];
		    array_push($x_t, ($row["id"] - $time_st) / 24 / 3600);
		    array_push($y_p, $p_now);
		    array_push($y_c, (0 - $c_now));
		    array_push($y_n, ($p_now - $c_now));
    }
}
else {
	  array_push($x_t, 0);
	  array_push($y_p, 0);
    array_push($y_c, 0);
    array_push($y_n, 0);
}

// close connection 
mysqli_close($conn);


		//==================================================================================
		// Create Chart Image 
		//==================================================================================
		
		  require_once ('chart_meter1_inc.php');
		  
		//==================================================================================
		// Create Temporary Local Variable for Table 
		//==================================================================================

			if ($tDay > 0) {
				  if ($cNow > $pNow) {
				     $m_tt = "Importing from grid ... by " . sprintf("%0.3f kW",  ($cNow - $pNow) / 1000);
				  }
				  else {
				     $m_tt = "Exporting to grid ... by " . sprintf("%0.3f kW",  ($pNow - $cNow) / 1000);
				  }
					$m_11 = date('m/d/Y H:i', $tTime - $tz_adj - $tz_err);
					$m_21 = sprintf("%0.3f kW",  $pNow / 1000);
					$m_22 = sprintf("%0.3f kW",  $cNow / 1000);
					$m_23 = sprintf("%0.3f kW",  ($cNow - $pNow) / 1000);
			}
			else {
				  $m_tt = 'Meter';
 				  $m_11 = '-';
					$m_21 = '0.000 kW';
					$m_22 = '0.000 kW';
					$m_23 = '0.000 kW';
			}
			
  	  $m_31 = sprintf("%0.3f kWh", $pDay / 1000);
	    $m_32 = sprintf("%0.3f kWh", $cDay / 1000);
	    $m_33 = sprintf("%0.3f kWh", ($cDay - $pDay) / 1000);
			if ($tDay > 10*60) {
				  $tDay = $tDay / 3600;
			    $m_31 = $m_31 . sprintf(" (%0.3f kW)", $pDay / 1000 / $tDay);
			    $m_32 = $m_32 . sprintf(" (%0.3f kW)", $cDay / 1000 / $tDay);
			    $m_33 = $m_33 . sprintf(" (%0.3f kW)", ($cDay - $pDay) / 1000 / $tDay);
		  }
		  
			$m_41 = sprintf("%0.3f kWh", $pSeven / 1000);
	    $m_42 = sprintf("%0.3f kWh", $cSeven / 1000);
	    $m_43 = sprintf("%0.3f kWh", ($cSeven - $pSeven) / 1000);
			if ($tSeven > 1*60*60) {
				  $tSeven = $tSeven / 24 / 60 / 60;
			    $m_41 = $m_41 . sprintf(" (%0.3f kWh)", $pSeven / 1000 / $tSeven);
			    $m_42 = $m_42 . sprintf(" (%0.3f kWh)", $cSeven / 1000 / $tSeven);
			    $m_43 = $m_43 . sprintf(" (%0.3f kWh)", ($cSeven - $pSeven) / 1000 / $tSeven);
		  }
		  
		  $m_51 = sprintf("%0.3f MWh", $pLife / 1000 / 1000);
	    $m_52 = sprintf("%0.3f MWh", $cLife / 1000 / 1000);
	    $m_53 = sprintf("%0.3f MWh", ($cLife - $pLife) / 1000 / 1000);

      if ($tDay > 0) {
				  $m_61 = sprintf("%0.1f V / %0.1f A", $pVolt, $pCurr);
			    $m_62 = sprintf("%0.1f V / %0.1f A", $cVolt, $cCurr);
			    $m_63 = sprintf("%0.1f V / %0.1f A", ($pVolt + $cVolt) / 2, ($cNow - $pNow) / (($pVolt + $cVolt) / 2));
		  }
		  else {
				  $m_61 = '-';
			    $m_62 = '-';
			    $m_63 = '-';
		  }
		  
		//==================================================================================

echo "
    <table style='width:100%'>
        <tr>
            <th colspan='4' bgcolor='#CCCCCC' align='left'><font size='4'> $m_tt </font></th>
        </tr>
        <tr> <th colspan='4' bgcolor='#FFFFFF'> </th></tr>
        <tr>
            <th width=25% bgcolor='#EEEEEE' align='left'> $m_11 </th>
            <th width=25% bgcolor='#F8F8F8'>Production</th>
            <th width=25% bgcolor='#F8F8F8'>Consumption</th>
            <th width=25% bgcolor='#F8F8F8'>NET Usage</th>
        </tr>
        <tr>
            <th bgcolor='#EEEEEE' align=left>Power</th>
            <td> $m_21 </td>
            <td> $m_22 </td>
            <td> $m_23 </td>
        </tr>
        <tr>
            <th bgcolor='#EEEEEE' align=left>Energy Today</th>
            <td> $m_31 </td>
            <td> $m_32 </td>
            <td> $m_33 </td>
        </tr>
        <tr>
            <th bgcolor='#EEEEEE' align=left>Energy 7 Days</th>
            <td> $m_41 </td>
            <td> $m_42 </td>
            <td> $m_43 </td>
        </tr>
        <tr>
            <th bgcolor='#EEEEEE' align=left>Energy Lifetime</th>
            <td> $m_51 </td>
            <td> $m_52 </td>
            <td> $m_53 </td>
        </tr>
        <tr>
            <th bgcolor='#EEEEEE' align=left>Voltage/Current</th>
            <td> $m_61 </td>
            <td> $m_62 </td>
            <td> $m_63 </td>
        </tr>
        <tr> <th colspan='4' bgcolor='#FFFFFF'> </th></tr>
        <tr> 
        		<th colspan='4' bgcolor='#FFFFFF'> 
        	     	<img src='chart_meter1.png' alt='Meter'>
        		</th>
        </tr>
    </table>";
   
?>