﻿<?php

// Create connection
$conn = mysqli_connect($dbserver, $username, $password, $database);

//=============================================================================
// Load and Set-up Panel Group Information
//=============================================================================
$gp_txt = array();
$gp_num = array();
$gp_tot = array();
$gp_avg = array();
$sql    = "SELECT * FROM solar_group ORDER BY id";
$res    = mysqli_query($conn, $sql);
$groups = mysqli_num_rows($res);
if ($groups > 0) {
   for ($i = 0; $i < $groups; $i++) {
       $row = mysqli_fetch_assoc($res);
       array_push($gp_txt, $row["title"]);
       array_push($gp_num, 0);
       array_push($gp_tot, 0);
       array_push($gp_avg, 0);
   }
}

//=============================================================================
// Load Each Panel Information using SerialNumber of uInverter
//=============================================================================
$im_num = array();   // serial number 
$im_now = array();   // current power output
$im_eng = array();   // energy calculation 
$im_avg = array();   // average power in a day
$im_max = array();   // maximum power in a day 
$im_idx = array();   // group number 
$im_p_x = array();
$im_p_y = array();
$im_p_l = array();
$sql    = "SELECT * FROM solar_panel ORDER BY id_index";
$res    = mysqli_query($conn, $sql);
$panels = mysqli_num_rows($res);
if ($panels > 0) {
   for ($i = 0; $i < $panels; $i++) {
       $row = mysqli_fetch_assoc($res);
       array_push($im_num, $row["id"]);
       array_push($im_idx, $row["id_group"]);
       array_push($im_p_x, $row["pos_x"]);
       array_push($im_p_y, $row["pos_y"]);
       array_push($im_p_l, $row["layout"]);
       array_push($im_now, 0);
       array_push($im_eng, 0);
       array_push($im_avg, 0);
       array_push($im_max, 0);
       $gp_num[$row["id_group"] - 1] += 1;
   }
}         

//==============================================================================
// Production for Last 3 Days include Today
//==============================================================================
$xx_t    = array();  // time table
$yy_t    = array();  // data table 
$yy_g    = array();  // group data table 
$time_st = intval((time() - $tz_adj) / 24 / 3600) * 24 * 3600 + $tz_adj;
$time_sd = $time_st - 2 * 24 * 3600;
$time_lt = $time_st + 1 * 24 * 3600;
$sql     = "SELECT * FROM solar_production WHERE id >= $time_sd AND id <= $time_lt ORDER BY id ASC";
$res     = mysqli_query($conn, $sql);
$found   = mysqli_num_rows($res);

// create group array for chart
for ($i = 0; $i < $groups; $i++) {
    array_push($yy_g, array());
}
    
if ($found > 0) {
	   
	  // convert to group data
	  $t_pre = 0;
	  $t_now = 0;
  	for ($index = 0; $index < $found; $index++) {
		    $row  = mysqli_fetch_assoc($res);
        $t_now = ($row["id"] - $time_st) / 24 / 3600;
		    array_push($xx_t, $t_now);
        for ($i = 0; $i < $groups; $i++) {
            $gp_tot[$i] = 0;
        }		    
        for ($i = 0; $i < $panels; $i++) {
            $w = $row[sprintf("wNow_%02d", $i + 1)];       	  
    	      $im_now[$i] = $w;
    	      $gp_tot[$im_idx[$i] - 1] += $w;
    	      if ($t_now >= 0) {
		    	  	  $im_avg[$i] += $w;
		    	      if ($im_max[$i] < $w) {
		    	      	 $im_max[$i] = $w;
		    	      }
		    	      $t_dev = $t_now - $t_pre;
		    	      if ($t_dev < (360/24/3600)) {
		    	         $im_eng[$i] += ($w * $t_dev);
		    	      }
		    	      else if ($t_dev < (1800/24/3600)) {
		    	      	 $im_eng[$i] += ($w * $t_dev  / 2);
		    	      }
		    	      else {
		    	         $im_eng[$i] += ($w * (60/24/3600));
		    	      }
		    	  }
		    	  else {
		    	  		$im_max[$i] = $w;
    	      }
        }
        for ($i = 0; $i < $groups; $i++) {
            array_push($yy_g[$i], $gp_tot[$i] / $gp_num[$i]);
        }
		    $t_pre = $t_now;		    
    }
    $t_time_01 = $row["id"];
   
    // group average 
	  for ($i = 0; $i < $groups; $i++) {
        $gp_avg[$i] = $gp_tot[$i] / $gp_num[$i];
    } 
    
    // panel average   
    $eToday = 0;
    for ($i = 0; $i < $panels; $i++) {
    	  $im_avg[$i] = $im_avg[$i] / $found;  
    	  $im_eng[$i] = $im_eng[$i] * 24;
    	  $eToday     = $eToday + $im_eng[$i];
    } 
}
else {
	
	  // dummy data 
	  array_push($xx_t, -100);
    for ($i = 0; $i < $groups; $i++) {
        array_push($yy_g[$i], 0);
    }
    
}

// close connection 
mysqli_close($conn);



		//==================================================================================
		// Create Chart Image 
		//==================================================================================
		
		  require_once ('chart_panel0_inc.php');
			require_once ('chart_panel1_inc.php');
			
		//==================================================================================
		// Create Temporary Local Variable for Table 
		//==================================================================================
		
		  $i_tt = "Micro-inverter";
		  if ($xx_t[0] > $time_st) {
         $i_11 = date('m/d/Y H:i', $t_time_01 - $tz_adj - $tz_err);		  	
 				 $i_21 = sprintf("%0.3f kW",  $iNow / 1000);
		  }
		  else {
		  	 $i_11 = '-';		  	
 				 $i_21 = '0.000 kW';
		  }
      $i_12 = sprintf("%d",  $panels);
			$i_22 = sprintf("%0.3f kWh / %0.3f MWh",  $eToday / 1000, $iLife / 1000 / 1000);		
				
		//==================================================================================
    
echo "
    <table style='width:100%'>
        <tr>
            <th colspan='8' bgcolor='#CCCCCC' align=left><font size='4'> $i_tt </font></th>
        </tr>
        <tr> <th colspan='8' bgcolor='#FFFFFF'> </th></tr>

        <tr>
            <th colspan='2' bgcolor='#EEEEEE' width=25% align=left>Report Data/Time</th>
            <td colspan='2'> $i_11 </td>
            <th colspan='2' bgcolor='#EEEEEE' width=25% align=left>Number</th>
            <td colspan='2'> $i_12 </td>
        </tr>
        <tr>
            <th colspan='2' bgcolor='#EEEEEE' width=25% align=left>Power</th>
            <td colspan='2'> $i_21 </td>
            <th colspan='2' bgcolor='#EEEEEE' width=25% align=left>Energy Today / Lifetime</th>
            <td colspan='2'> $i_22 </td>
        </tr>
        <tr> <th colspan='8' bgcolor='#FFFFFF'> </th></tr>
        <tr>
            <th rowspan='2' width=7%  bgcolor='#F8F8F8'>Group</th>
            <th rowspan='2' width=18% bgcolor='#F8F8F8'>Serial Number</th>
            <th colspan='2' width=25% bgcolor='#F8F8F8'>Today</th>
            <th colspan='2' width=25% bgcolor='#F8F8F8'>Power</th>
            <th colspan='2' width=25% bgcolor='#F8F8F8'>Group</th>
        </tr>
        <tr>
            <th width=12% bgcolor='#F8F8F8'>Average</th>
            <th width=13% bgcolor='#F8F8F8'>Production</th>
            <th width=12% bgcolor='#F8F8F8'>Now</th>
            <th width=13% bgcolor='#F8F8F8'>Maximum</th>
            <th width=12% bgcolor='#F8F8F8'>Average</th>
            <th width=13% bgcolor='#F8F8F8'>Total</th>
        </tr>";
        
     $index = 0;
     for ($group_index = 0; $group_index < count($gp_txt); $group_index++) {
     	   $gnum = $gp_num[$group_index];
     	   $i_01 = sprintf("%d W",  $im_avg[$index]);
     	   $i_02 = sprintf("%d Wh", $im_eng[$index] + 0.5);
     	   $i_03 = sprintf("%d W",  $im_now[$index]);
     	   $i_04 = sprintf("%d W",  $im_max[$index]);
     	   $i_11 = sprintf("%d W", $gp_avg[$group_index]);
     	   $i_12 = sprintf("%0.3f kW", $gp_tot[$group_index] / 1000);
     	   if ($show_sn) {
     	   	   $i_no = $im_num[$index];
     	   }
     	   else {
             $i_no = intval($im_num[$index] / 100000) * 100000 + $group_index * 1000;      // Hide Real Serial Number 
         }
	       $index += 1;       
echo "   <tr> <th colspan='8' bgcolor='#FFFFFF'> </th></tr>
	       <tr>
	            <th rowspan='$gnum'>  $gp_txt[$group_index] </th>
	            <td align=center> $i_no </td>
	            <td align=right> $i_01 </td>
	            <td align=right> $i_02 </td>
	            <td align=right> $i_03 </td>
	            <td align=right> $i_04 </td>
	            <td rowspan='$gnum' align=right> $i_11 </td>
	            <td rowspan='$gnum' align=right> $i_12 </td>
	       </tr>";
	   	   for ($panel_index = 1; $panel_index < $gnum; $panel_index++) { 
	   	   	   $i_01 = sprintf("%d W",  $im_avg[$index]);
	       	   $i_02 = sprintf("%d Wh", $im_eng[$index] + 0.5);
	     	     $i_03 = sprintf("%d W",  $im_now[$index]);
	     	     $i_04 = sprintf("%d W",  $im_max[$index]);
		     	   if ($show_sn) {
		     	   	   $i_no = $im_num[$index];
		     	   }
		     	   else {
		             $i_no = intval($im_num[$index] / 100000) * 100000 + $group_index * 1000 + $panel_index;      // Hide Real Serial Number 
		         }
	       		 $index += 1;
echo "   <tr>
	            <td align=center> $i_no </td>
	            <td align=right> $i_01 </td>
	            <td align=right> $i_02 </td>
	            <td align=right> $i_03 </td>
	            <td align=right> $i_04 </td>
	       </tr>";
	       }
     }
echo "   <tr> <th colspan='8' bgcolor='#FFFFFF'> </th></tr>
	       <tr>
	          <th colspan='8' bgcolor='#FFFFFF'>
	              <img src='chart_panel0.png' alt='Panel Layout'>
	              <img src='chart_panel1.png' alt='Each Group Production'>
	          </th>
	       </tr>
	      </table>";
?>